#include <bits/stdc++.h>
using namespace std;

#define rep(i, a, b) for(int i = a; i < (b); i++)
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
typedef long long ll;
typedef pair<int,int> pii;
typedef vector<ll> vi;


int N;
vi x;
vi y;
vi r;
vector<vector<int>> graph;
vector<bool> visited;
vector<bool> allcolor;
int currtrue;
int currfalse;

ll d(ll x) {
  return x*x;
}

// cannot twocolor
bool dfs_problem(int at, int par, bool color) {
  //cerr << "checking " << at << endl;
  if (visited[at] && allcolor[at] != color) return true;
  if (visited[at]) return false;
  visited[at] = true;
  //cerr << "visiting " << at << endl;
  for (int neigh : graph[at]) {
    if (visited[neigh] && allcolor[neigh] == color) return true;
  }
  allcolor[at] = color;
  if (color) {
    currtrue++;
  } else {
    currfalse++;
  }
  for(int child : graph[at]) {
    if (child == par) continue;
    if (dfs_problem(child, at, !color)) return true;
  }
  return false;
}
bool dfs_ok(int node, int last, bool color) {
  if (visited[node] && allcolor[last] == color) return false;
  if (visited[node]) return true;
  visited[node] = true;
  if (color) {
    currtrue++;
  } else {
    currfalse++;
  }
  allcolor[node] = color;
  for (int nei : graph[node]) {
    if (nei == last) continue;
    if (!dfs_ok(nei, node, !color)) return false;
  }
  return true;
}

int main() {
  cin.tie(0)->sync_with_stdio(0);
  cin.exceptions(cin.failbit);

  cin >> N;
  x = vi(N);
  y = vi(N);
  r = vi(N);
  rep(i, 0, N) {
    cin >> x[i] >> y[i] >> r[i];
  }
  graph = vector<vector<int>>(N);
  rep(i, 0, N) {
    rep(j, 0, i) {
      if (d(x[i]-x[j]) + d(y[i]-y[j]) == d(r[i]+r[j])) {
        // tangent
        graph[i].push_back(j);
        graph[j].push_back(i);
      }
    }
  }
  visited = vector<bool>(N);
  allcolor = vector<bool>(N);
  rep(i, 0, N) {
    if (visited[i]) continue;
    currtrue = 0;
    currfalse = 0;
    //cerr << "new component" << endl;
    
    //if (!dfs_problem(i, -1, false)) {
    if (dfs_ok(i, -1, false)) {
      if (currtrue != currfalse) {
        //cerr << "comp possible" << endl;
        cout << "YES" << endl;
        return 0;
      } else {
        //cerr << "comp imposible diffnumcolor" << endl;
      }
    } else {
      //cerr << "comp imposible twocolor" << endl;
    }
  }
  cout << "NO" << endl;
}
